package cn.net.caoyao.cpzshandset.service.presenter.impl.setting.yth;

import java.util.ArrayList;
import java.util.List;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.widget.Toast;
import cn.net.caoyao.cpzshandset.bean.ConfigBean;
import cn.net.caoyao.cpzshandset.common.bitmap.MBitmapService;
import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.HandsetSettingOption;
import cn.net.caoyao.cpzshandset.common.config.HandsetVersionConstant;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.common.config.SDCardConfig;
import cn.net.caoyao.cpzshandset.common.util.NetWorkUtils;
import cn.net.caoyao.cpzshandset.service.bll.ConsigneeBll;
import cn.net.caoyao.cpzshandset.service.bll.ProductBll;
import cn.net.caoyao.cpzshandset.service.bll.TrainStationBll;
import cn.net.caoyao.cpzshandset.service.bll.config.ConfigBll;
import cn.net.caoyao.cpzshandset.service.presenter.SettingConstact;
import cn.net.caoyao.cpzshandset.service.presenter.base.impl.SettingConstactImpl;
import cn.net.caoyao.cpzshandset.service.thread.ThreadPoolManager;
import cn.net.caoyao.cpzshandset.service.thread.ThreadReqTools;
import cn.net.caoyao.cpzshandset.service.thread.impl.yth.YthReqConsigeeRunable;
import cn.net.caoyao.cpzshandset.service.thread.impl.yth.YthReqTrainStationRunable;
import cn.net.caoyao.cpzshandset.service.thread.impl.ythImage.DownloadImageRunable;
import cn.net.caoyao.cpzshandset.ui.activity.DeviceIdConfigActivity;
import cn.net.caoyao.cpzshandset.ui.activity.ModifyHandsetVersionActivity;
import cn.net.caoyao.cpzshandset.ui.adapter.SettingAdapter;
import cn.net.caoyao.cpzshandset.ui.weight.DialogUtils;
import cn.net.cpzslibs.prot.bean.res.Prot10050ResBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20001ResBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20012ResBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20013ResBean;
import cn.net.handsetlib.utils.ReadDeviceIDUtil;

public class YthSettingPresenter extends SettingConstactImpl{
	private final SettingConstact.View sView;
	private Context context;
	private List<HandsetSettingOption> beans = new ArrayList<HandsetSettingOption>();
	private ConfigBll configBll;
	private ProductBll productBll;
	private TrainStationBll stationBll;
	private ConsigneeBll consigneeBll;
	private ProgressDialog bProgressDialog = null;
	private List<String> beforeImages;
	private MBitmapService bitmapService;
	private int currentHandsetVersion = HandsetVersionConstant.HANDSET_YTH_VERSION_MODE;
	private Handler mHandler = new Handler(){
		public void handleMessage(android.os.Message msg) {
			switch (msg.what) {
			case RequestConstant.REQUEST_FAIL:
				//请求失败
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("请求失败！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT:
				//超时
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("请求超时！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PROT01_LOGIN_FAIL:
				//登录失败
				if (!checkViewAvailable())return;
				dismissProgress();
				String errorMsg = msg.obj.toString();
				int errorCode = msg.arg1;
				sView.showMsgToast(errorMsg + errorCode, Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PRODUCT_LIST_SUCCESS:
				//请求产品信息成功
				if (!checkViewAvailable())return;
				bProgressDialog.setMessage("产品列表请求成功，开始请求产品图片信息");
				downloadPImage();
				
//				dismissProgress();
//				sView.showMsgToast("请求产品信息成功！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PRODUCT_LIST_FAIL:
				//请求产品信息失败
				if (!checkViewAvailable())return;
				dismissProgress();
				Prot20001ResBean resBean = (Prot20001ResBean) msg.obj;
				sView.showMsgToast("请求失败 错误码：" + resBean.getErrcode(), Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PRODUCT_LIST_IS_EMPTY:
				if (!checkViewAvailable())return;
				dismissProgress();
				String errorMsg1 = msg.obj.toString();
				int errorCode1 = msg.arg1;
				sView.showMsgToast(errorMsg1 + errorCode1, Toast.LENGTH_SHORT);
				break;
			case RequestConstant.DOWNLOAD_PRODUCT_IMAGE_SUCCESS:
				if (!checkViewAvailable())return;
				dismissProgress();
				sView.showMsgToast("产品图片下载完成", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_STATION_10050_NO_DATA:
				//无地址信息
				if (!checkViewAvailable()) return;
				sView.showMsgToast("请求成功，但未获取到地址信息",Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_STATION_10050_FAIL:
				//请求地址信息失败
				if (!checkViewAvailable()) return;
				dismissProgress();
				Prot10050ResBean resBean1 = (Prot10050ResBean) msg.obj;
				if (resBean1 != null) {
//					res = resBean.getErrmsg()+resBean.getErrcode();
					sView.showMsgToast(ThreadReqTools.getErrorMsg(resBean1.getErrcode()) +"错误码："+ resBean1.getErrcode(),Toast.LENGTH_SHORT);
				} else {
					sView.showMsgToast("请求地址列表失败!",Toast.LENGTH_SHORT);
				}
				break;
			case RequestConstant.PROT_REQ_STATION_10050_SUCCESS:
				if (!checkViewAvailable()) return;
				dismissProgress();
				sView.showMsgToast("地址列表更新成功",Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_TRAIN_STATION_20012_NO_DATA:
				//无地址信息
				if (!checkViewAvailable()) return;
				sView.showMsgToast("请求成功，但未获取到地址信息",Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_TRAIN_STATION_20012_FAIL:
				//请求地址信息失败
				if (!checkViewAvailable()) return;
				dismissProgress();
				Prot20012ResBean resBean2 = (Prot20012ResBean) msg.obj;
				if (resBean2 != null) {
//					res = resBean.getErrmsg()+resBean.getErrcode();
					sView.showMsgToast(ThreadReqTools.getErrorMsg(resBean2.getErrcode()) +"错误码："+ resBean2.getErrcode(),Toast.LENGTH_SHORT);
				} else {
					sView.showMsgToast("请求地址列表失败!",Toast.LENGTH_SHORT);
				}
				break;
			case RequestConstant.PROT_REQ_TRAIN_STATION_20012_SUCCESS:
				if (!checkViewAvailable()) return;
				dismissProgress();
				sView.showMsgToast("地址列表更新成功",Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_CONSIGEE_20013_NO_DATA:
				//无地址信息
				if (!checkViewAvailable()) return;
				sView.showMsgToast("请求成功，但未获取到收货人信息",Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_CONSIGEE_20013_FAIL:
				//请求地址信息失败
				if (!checkViewAvailable()) return;
				dismissProgress();
				Prot20013ResBean resBean3 = (Prot20013ResBean) msg.obj;
				if (resBean3 != null) {
//					res = resBean.getErrmsg()+resBean.getErrcode();
					sView.showMsgToast(ThreadReqTools.getErrorMsg(resBean3.getErrcode()) +"错误码："+ resBean3.getErrcode(),Toast.LENGTH_SHORT);
				} else {
					sView.showMsgToast("请求收货人信息失败!",Toast.LENGTH_SHORT);
				}
				break;
			case RequestConstant.PROT_REQ_CONSIGEE_20013_SUCCESS:
				if (!checkViewAvailable()) return;
				dismissProgress();
				sView.showMsgToast("收货人信息更新成功",Toast.LENGTH_SHORT);
				break;
				
			}
		}

		
	};
	
	private void downloadPImage() {
		ThreadPoolManager.getThreadPool().execute(new DownloadImageRunable(mHandler, getProductBll().queryAllImage(), beforeImages, bitmapService));			
	};
	public YthSettingPresenter(SettingConstact.View sView,Context context) {
		this.sView = sView;
		this.context = context;
		start();
	}

	@Override
	public void start() {
		if (!checkViewAvailable()) return;
		configBll = new ConfigBll(context);
		stationBll = new TrainStationBll(context);
		consigneeBll = new ConsigneeBll(context);
		bitmapService = MBitmapService.create(MBitmapService.getInstance(context), context, SDCardConfig.getImageCachePath(context));
		initSettingData();
		SettingAdapter adapter = new SettingAdapter(beans);
		sView.setAdapter(adapter);
	}

	private void initSettingData() {
		beans.add(HandsetSettingOption.SETTING_CONFIG_DEVICE_ID_MODE);
		beans.add(HandsetSettingOption.SETTING_UPDATE_ADDRESS_LIST_MODE);
//		beans.add(new HomeBean(HandsetSettingOptionConstant.SETTING_UPDATE_PRODUCT_LIST_MODE,0,"更新产品列表"));
		beans.add(HandsetSettingOption.SETTING_UPDATE_CONSIGNEE_LIST_MODE);
		if (Config.canSwitchHandsetVersionMode) {
			beans.add(HandsetSettingOption.SETTING_HANDSET_MODE_SWITCH_MODE);
		}
	}

	@Override
	public boolean checkViewAvailable() {
		boolean b = false;
		if (sView != null && context != null) {
			b = true;
		}
		return b;
	}

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		
	}

	@Override
	public Handler getHandler() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void onItemClickListener(int position) {
		swithSettingOption(beans.get(position));
	}
	public void dismissProgress() {
		if (bProgressDialog != null) {
			try {
				DialogUtils.dismissProgressDialog(bProgressDialog);
			} catch (Exception e) {
			}
		}
	}

	/**
	 * 提示正在更新数据
	 */
	protected void showProgressDialog(String titleStr, String tipsMsg) {
		bProgressDialog = DialogUtils.showProgressDialog(bProgressDialog, titleStr,
				tipsMsg, context);
	}
	private void swithSettingOption(HandsetSettingOption setOption) {
		switch (setOption) {
		case SETTING_HANDSET_MODE_SWITCH_MODE:
			//修改手持机版本模式
//			sView.showMsgToast("修改手持机版本模式", Toast.LENGTH_SHORT);
			Intent modifyVersionIntent = new Intent(context, ModifyHandsetVersionActivity.class);
			context.startActivity(modifyVersionIntent);
			break;
		case SETTING_CONFIG_DEVICE_ID_MODE:
			//配置设备ID
//			sView.showMsgToast("配置设备ID", Toast.LENGTH_SHORT);
			Intent intent = new Intent(context, DeviceIdConfigActivity.class);
			context.startActivity(intent);
			break;
		case SETTING_UPDATE_PRODUCT_LIST_MODE:
			//更新产品列表
//			sView.showMsgToast("更新产品列表", Toast.LENGTH_SHORT);
			ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHandsetVersion);
			if (configBean != null) {
				if (!NetWorkUtils.isNetworkConnected(context)) {
					DialogUtils.showSetNetDialog(context);
					return;
				}
				showProgressDialog("提示", "正在请求产品信息，请稍后……");
				 long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
				 beforeImages = getProductBll().queryAllImage();
//				 ThreadPoolManager.getThreadPool().execute(new YthImageUpdateProductListThread(mHandler,deviceId,getProductBll()));
			} else {
				sView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			}
			break;
		case SETTING_UPDATE_AGENCY_LIST_MODE:
			//更新经销商列表
			// TODO 通用版暂时未用到
			break;
		case SETTING_UPDATE_AUTHENTICITY_GUARANTEED_LIST_MODE:
			//更新正品保证单
			// TODO 通用版暂时未用到
			break;
		case SETTING_UPDATE_ADDRESS_LIST_MODE:
			//更新地址列表
			ConfigBean configBean1 = configBll.queryConfigByHandsetMode(currentHandsetVersion);
			if (configBean1 != null) {
				if (!NetWorkUtils.isNetworkConnected(context)) {
					DialogUtils.showSetNetDialog(context);
					return;
				}
				showProgressDialog("提示", "正在请求地址信息，请稍后……");
				 long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean1.getDeviceId()));
				 ThreadPoolManager.getThreadPool().execute(new YthReqTrainStationRunable(mHandler, deviceId, stationBll));
			} else {
				sView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			}
			break;
		case SETTING_MODIFY_PWD_LIST_MODE:
			//修改登录密码
			// TODO 通用版暂时未用到
			break;
		case SETTING_UPDATE_CONSIGNEE_LIST_MODE:
			ConfigBean cB = configBll.queryConfigByHandsetMode(currentHandsetVersion);
			if (cB != null) {
				if (!NetWorkUtils.isNetworkConnected(context)) {
					DialogUtils.showSetNetDialog(context);
					return;
				}
				showProgressDialog("提示", "正在请求收货人信息，请稍后……");
				 long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(cB.getDeviceId()));
				 ThreadPoolManager.getThreadPool().execute(new YthReqConsigeeRunable(mHandler, deviceId, consigneeBll));
			} else {
				sView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			}
			break;
		}
	}


	private ProductBll getProductBll() {
		if (productBll == null) {
			productBll = new ProductBll(context);
		}
		return productBll;
	}

}
